
/* Portions Copyright (c) 1995,1996,1997 by Trusted Information Systems, Inc.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND TRUSTED INFORMATION SYSTEMS DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL TRUSTED INFORMATION 
 * SYSTEMS BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
 * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
 * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 *
 * Trusted Information Systems, Inc. has received approval from the
 * United States Government for export and reexport of TIS/DNSSEC
 * software from the United States of America under the provisions of
 * the Export Administration Regulations (EAR) General Software Note
 * (GSN) license exception for mass market software.  Under the
 * provisions of this license, this software may be exported or
 * reexported to all destinations except for the embargoed countries of
 * Cuba, Iran, Iraq, Libya, North Korea, Sudan and Syria.  Any export
 * or reexport of TIS/DNSSEC software to the embargoed countries
 * requires additional, specific licensing approval from the United
 * States Government. 
 */





static char *rcsid ="$Header: /home/ogud/sec_bind/signer/RCS/get_key.c,v 1.3 1997/01/22 22:04:20 ogud Exp $";

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <netinet/in.h> 
#include "../include/arpa/nameser.h" 
#include "dnssec.h"

int do_axfr ;
void
main(argc, argv) 
int argc;
char **argv;
{
  KEY *key; 
  u_char buff[1024],out[1024],*name=(u_char *) "teste", *ptr;
  int fp,no,nn,ft;
  if(argc > 1) 
    name=(u_char *) argv[1];
    key = dnssec_getkey( name, DNSSEC_FORCE_READ); 
    if(key) {
      printf("Private Key Footprint %d size %d\n",
	     (int) key->foot, (int) key->key_size);
      sprintf(out, "%s.public",name);
      fp=open(out, O_RDONLY);
      if(fp) { 
	no = read(fp, buff, sizeof(buff));
	if( no > 0) {
	  ptr = (u_char *) strrchr(buff,' ') +1;
	  nn = decode64( ptr, out, &buff[no-1]-ptr);
	  ft = (u_int) out[nn-3] * 256 + (u_int) out[nn-2];
	  nn = nn - out[0] -1;
	  printf ("Public Key footprint %d size %d \n", ft, nn*8);
	}
	else 
	  printf ("Public Key not found\n");
      }
    }
    else 
      printf("Failed reading in key %s\n", name);
}
